# display help notice
sub dishelp() {
    my(@args) = @_;
    my $hash_ref = $_[0];
    my $help01a=$hash_ref->{help}->{help01a};                
    my $help01b=$hash_ref->{help}->{help01b};                
    my $help01c=$hash_ref->{help}->{help01c};                
    my $help02=$hash_ref->{help}->{help02};
    my $help03=$hash_ref->{help}->{help03};
    my $help04=$hash_ref->{help}->{help04};
    my $help05=$hash_ref->{help}->{help05};
    my $help06=$hash_ref->{help}->{help06};
    print "$help01a \n$0 $help01b\n";
    print "$0 $help01c\n";
    print " \n";
    print "$help02\n";
    print "$help03\n";
    print "$help04\n";
    print "$help05\n";
    print " \n";
    print "$help06\n";
    return 3;
}

# function trim for suppress leadind spaces
sub trim {
    (my $s = $_[0]) =~ s/^\s+|\s+$//g;
    return $s;        
}

sub display_usage()
    {
    print "Usage : check_apcupsd.new.pl\n";
    print "\n";
    print "Missing argument: $_[0]\n";
    }


# check si ARGS are availables
sub checkargs() {
    my(@args) = @_;
    my $hash_ref = $_[0];
    my $WARN  = $_[1];
    my $CRIT  = $_[2];
    if ($WARN eq '' or $CRIT eq '')
        {
        my $bchargeC=$hash_ref->{error}->{error03a};
        &dishelp($hash_ref);
	return 3;
        }
    return 0;
}

sub get_ini_path(){
    #
    my(@args) = @_;
    my $path_to_ini = $_[0];
    #
    $PATH='';
    if (substr($path_to_ini,0,1) eq '/')
    {
        #absolute path
        $PATH = $path_to_ini;
    }
    else 
    {
        $PATH = `dirname $0`;
        $PATH = substr($PATH, 0, -1);
        if ($PATH eq '.')
        {
            $PATH = $path_to_ini;
        }
        else
        {
            if (substr($PATH,0,2) eq "./")
            {
                $PATH=substr($PATH,2);
            }
            $PATH = "${PATH}/${path_to_ini}";
        }
    }


   if ($PATH ne '')
   {
       $PATH="${PATH}/";
   }
   return $PATH;
}

sub test_apaccess () {
$dummy=`$APCA`;
if ($? == -1)
    {
    my(@args) = @_;
    my $hash_ref = $_[0];
    my $text01a=$hash_ref->{error}->{error01a};                
    my $text01b=$hash_ref->{error}->{error01b};                
    print "$text01a '$APCA' $text01b\n";
    return 3;
    }
    return 0;
}

sub action_load() {
    my(@args) = @_;
    my $hash_ref  = $_[0];
    my $WARN      = $_[1];
    my $CRIT      = $_[2];
    my $APCA      = $_[3];
    my $APCA_ARGS = $_[4];

    &checkargs($hash_ref, $WARN, $CRIT);
    my $LOAD=`$APCA $APCA_ARGS | grep LOAD`;
    # filter the output
    $LOAD = trim(substr $LOAD,11,5);
    my $loadC=$hash_ref->{load}->{loadC};                
    my $loadW=$hash_ref->{load}->{loadW};
    my $load0=$hash_ref->{load}->{load0};

    if  ($LOAD > $CRIT )
        {
	print "$loadC - Load:  ${LOAD}% > $CRIT%\n";
	return 2;
        }
    if ($LOAD > $WARN)
        {
	print "$loadW - Load:  ${LOAD}% > $WARN%\n";
	return 1;
        }			
    print "$load0 - LOAD: ${LOAD}%\n";
    return 0;
}

sub action_bcharge () {
    my(@args) = @_;
    my $hash_ref  = $_[0];
    my $WARN      = $_[1];
    my $CRIT      = $_[2];
    my $APCA      = $_[3];
    my $APCA_ARGS = $_[4];

    &checkargs($hash_ref, $WARN, $CRIT);
    my $CHRG=`$APCA $APCA_ARGS | grep BCHARGE`;
    #filtrer the output
    $CHRG = trim(substr $CHRG,11,5);
    my $bchargeC=$hash_ref->{bcharge}->{bchargeC};                
    my $bchargeW=$hash_ref->{bcharge}->{bchargeW};
    my $bcharge0=$hash_ref->{bcharge}->{bcharge0};

    if ($CHRG < $CRIT)
        {
	print "$bchargeC :  ${CHRG}% < $CRIT%\n";
	return 2;
        }		
	if ($CHRG < $WARN)
            {
            print "$bchargeW :  ${CHRG}% < $WARN%\n";
            return 1;
            }
        print "$bcharge0 : ${CHRG}%\n";
	return 0;
}

sub action_time () {
    my(@args) = @_;
    my $hash_ref  = $_[0];
    my $WARN      = $_[1];
    my $CRIT      = $_[2];
    my $APCA      = $_[3];
    my $APCA_ARGS = $_[4];

    &checkargs($hash_ref, $WARN, $CRIT);
    my $TLEFT=`$APCA $APCA_ARGS | grep TIMELEFT`;
    #filtrer the output
    $TLEFT = trim(substr $TLEFT,11,5);

    my $timeC=$hash_ref->{time}->{timeC};                
    my $timeW=$hash_ref->{time}->{timeW};
    my $time0=$hash_ref->{time}->{time0};
    my $timeU=$hash_ref->{time}->{timeU};

    if ($TLEFT < $CRIT)
        {
	print "$timeC :  ${TLEFT} $timeU < $CRIT $timeU\n";
	return 2;
	}
    if ($TLEFT < $WARN)
        {
        print "$timeW :  ${TLEFT} $timeU < $WARN $timeU\n";
        return 1;
        }
    print "$time0 : ${TLEFT} $timeU\n";
    return 0;
}


sub action_status () {
    my(@args) = @_;
    my $hash_ref  = $_[0];
    my $APCA      = $_[1];
    my $APCA_ARGS = $_[2];
    #no test of parameters is needed
    my $ONLINE=`$APCA $APCA_ARGS | grep STATUS`;
    #filtrer the output
    $ONLINE = trim(substr $ONLINE,11,6);
    my $statusC=$hash_ref->{status}->{statusC};
    my $status0=$hash_ref->{status}->{status0};
    if ($ONLINE ne "ONLINE")
        {
        print "$statusC - ${ONLINE}\n";
        return 2;
        }
    print "$status0 - ${ONLINE}\n";
    return 0;
}

return true;

